/*********************************************************************
*                     SEGGER Microcontroller GmbH                    *
*                        The Embedded Experts                        *
**********************************************************************
*                                                                    *
*       (c) 1995 - 2025 SEGGER Microcontroller GmbH                  *
*                                                                    *
*       Internet: segger.com  Support: support_embos@segger.com      *
*                                                                    *
**********************************************************************
*                                                                    *
*       embOS * Real time operating system                           *
*                                                                    *
*       Please note:                                                 *
*                                                                    *
*       Knowledge of this file may under no circumstances            *
*       be used to write a similar product or a real-time            *
*       operating system for in-house use.                           *
*                                                                    *
*       Thank you for your fairness !                                *
*                                                                    *
**********************************************************************
*                                                                    *
*       OS version: V5.20.0.0                                        *
*                                                                    *
**********************************************************************

----------------------------------------------------------------------
File    : OS_InitSysStackInfo.c
Purpose : Initialize stack info variables needed by embOS
--------  END-OF-HEADER  ---------------------------------------------
*/

#include "RTOS.h"

/*********************************************************************
*
*       Reference to other modules
*
**********************************************************************
*/

extern unsigned long Image$$ARM_LIB_STACK$$ZI$$Limit;  // Defined by the linker
extern unsigned long Image$$ARM_LIB_STACK$$Base;       // Defined by the linker

/*********************************************************************
*
*       OS_InitSysStackInfo
*/
void OS_InitSysStackInfo(void) {
  OS_SysStackBaseAddr = (unsigned long) &Image$$ARM_LIB_STACK$$Base;
  OS_SysStackSize     = (unsigned int) ((unsigned long)&Image$$ARM_LIB_STACK$$ZI$$Limit - (unsigned long)&Image$$ARM_LIB_STACK$$Base);
  OS_SysStackLimit    = (unsigned long) &Image$$ARM_LIB_STACK$$ZI$$Limit;
}
  								   
/*****  End of File  ************************************************/
